#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#pragma hdrstop
#include <lm.h>
#include "nt95delayload.h"



void __stdcall FillSessionListNT( const char *server, const char *client, const char *user, SessionList& sl )
{
	SESSION_INFO_10 *buf;
	SESSION_INFO_10 *cur;
	DWORD read, total, resumeh, rc, i;
	char tt[MAXLEN];
	wchar_t *wserver = NULL, *wclient = NULL, *wuser = NULL;

	if ( server != NULL )
	{
		wserver = (wchar_t *) malloc( ( strlen( server ) + 10 ) * 2 );
		mbstowcs( wserver, server, -1 );
	}

	if ( client != NULL )
	{
		wclient = (wchar_t *) malloc( ( strlen( client ) + 10 ) * 2 );
		mbstowcs( wclient, client, -1 );
	}

	if ( user != NULL )
	{
		wuser = (wchar_t *) malloc( ( strlen( user ) + 10 ) * 2 );
		mbstowcs( wuser, user, -1 );
	}

	resumeh = 0;
	do
	{
		buf = NULL;

		// NOTE: pre-Jul98 Platform SDKs had bugs in the headers
		// and required a cast for the first three args (to char*).
		rc = NetSessionEnum( wserver, wclient, wuser, 10,
			(BYTE **) &buf, 2048, &read, &total, &resumeh );
		if ( rc != ERROR_MORE_DATA && rc != ERROR_SUCCESS )
			break;

		if ( (DWORD) ( sl.nReserved - sl.nUsed ) < read )
		{
			// make some room in the list
			sl.s = (Session *) realloc( sl.s, ( sl.nReserved + max( CHUNK, read ) ) * sizeof sl.s[0] );
			if ( sl.s == NULL )
			{
				printf( "Unable to get memory for %d additional sessions.\n", max( CHUNK, read ) );
				exit( 1 );
			}
			sl.nReserved += max( CHUNK, read );
		}

		printf( "\ngot %lu entries out of %lu\n", read, total );
		for ( i = 0, cur = buf; i < read; ++ i, ++ cur )
		{
			memset( &sl.s[sl.nUsed], '\0', sizeof sl.s[sl.nUsed] );
			if ( cur->sesi10_cname != NULL )
			{
				wcstombs( tt, cur->sesi10_cname, MAXLEN );
				sl.s[sl.nUsed].client = strdup( tt );
			}
			if ( cur->sesi10_username != NULL )
			{
				wcstombs( tt, cur->sesi10_username, MAXLEN );
				sl.s[sl.nUsed].user = strdup( tt );
			}
			sl.s[sl.nUsed].time = cur->sesi10_time;
			++ sl.nUsed;
		}

		if ( buf != NULL )
			NetApiBufferFree( buf );

	} while ( rc == ERROR_MORE_DATA );

	if ( rc != ERROR_SUCCESS )
		printf( "NSE() returned %lu\n", rc );

	free( wserver );
	free( wclient );
	free( wuser );
}
